using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Net.Http;
using Newtonsoft.Json.Linq;
					
public class Program
{
	public static async Task Main()
	{
		// Request parameters
		string apiKey = "PCW45-12345-12345-1234X";
		string to = "07500123456";
		string from = "Example.com";
		string message = "Hello from [from]. Your security code is [otp]. It will expire in [expiry] minutes. Do not share this code.";
		int otpLength = 6;
		int expiry = 5;

		// Prepare request and encode user-entered parameters with %xx encoding
		string requestUrl = $"https://ws.postcoder.com/pcw/{apiKey}/otp/send";
		
		var content = new Dictionary<string, string>
		{
			{ "to", to },
			{ "from", from },
			{ "message", message },
			{ "otplength", otpLength },
			{ "expiry", expiry }
		};
		var encodedContent = new FormUrlEncodedContent(content);

		using (HttpClient client = new HttpClient())
		{
			// Make request to send OTP via SMS
			var response = await client.PostAsync(requestUrl, encodedContent);
			var responseContent = await response.Content.ReadAsStringAsync();

			// Get ID to use with the otp/verify endpoint
			if (response.IsSuccessStatusCode)
			{
				JObject responseJson = JObject.Parse(responseContent);
				Console.WriteLine(responseJson["id"]);
			}
			else
			{
				Console.WriteLine($"Request error: {responseContent}");
			}
		}
	}
}