using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using System.Net.Http;
using Newtonsoft.Json.Linq;
					
public class Program
{
	public static async Task Main()
	{
		// Request parameters; ID is provided by the otp/send endpoint
		string apiKey = "PCW45-12345-12345-1234X";
		string id = "OTP45-12345-12345-1234X";
		string otp = "532132";

		// Prepare request and encode user-entered parameters with %xx encoding
		string requestUrl = $"https://ws.postcoder.com/pcw/{apiKey}/otp/verify";
		
		var content = new Dictionary<string, string>
		{
			{ "id", id },
			{ "otp", otp }
		};
		var encodedContent = new FormUrlEncodedContent(content);

		using (HttpClient client = new HttpClient())
		{
			// Send request
			var response = await client.PostAsync(requestUrl, encodedContent);
			var responseContent = await response.Content.ReadAsStringAsync();

			// Process response
			if (response.IsSuccessStatusCode)
			{
				JObject responseJson = JObject.Parse(responseContent);
				Console.WriteLine(responseJson["valid"]);
			}
			else
			{
				Console.WriteLine($"Request error: {responseContent}");
			}
		}
	}
}